package Format::Explainer;

sub new {
    my($class,$title,$text)=@_;
    my (%self)=(
		title => $title, 
		text=> $text,
		children => [] , 
		type => root,
		result => '');
    bless \%self,$class;
}

sub newSubStep {
    my ($self,$title,$text)=@_;
    my ($child)=new Format::Explainer($title,$text);
    push(@{$self->{'children'}},$child);
    $child->{'type'}="child";
    return $child;
}

sub addResult {
    my ($self,$result)=@_;
    $self->{'result'} .= $result;
}

sub formatTitle {
    my ($self)=@_;
    my ($title)=$self->{'title'};
    return qq!<div class='expltitle'><img class="toggle" alt="toggle" src="/graphics/plus.gif" onclick='javascript:toggleChildren(this);'><span>!    . $title . qq!</span></div>\n!;
}

sub toHTML {
    my($self,$depth)=@_;
    my(@result)=$self->formatTitle;
    my($text)=$self->{text};
    if ($text ne "") {
        push(@result,"<div class='children'>$text</div>\n");
    }

    my (@children)=@{$self->{'children'}};
    if (@children) {
        push(@result,"<div class='children'>");
        foreach $child (@children) {
	    push(@result , $child->toHTML);
	}
        push(@result,"</div>");
    }
    if ($self->{'result'} ne '') {
	push(@result,"<div>Result:  <span class='result'>".$self->{'result'}."</span></div>");
    }

    return ("<div class='explainnode'>",@result,"</div>");
}

1;
