package Format::HTML;

@suitsymms=(
	'<font style="color:black">&spades;</font>',
	'<font style="color:red">&hearts;</font>',
	'<font style="color:red">&diams;</font>',
	'<font style="color:black">&clubs;</font>'
);

sub new {
   my($class,$cgi)=@_;
   print $cgi->header('text/html');
   bless {},$class;
}

sub formatStart {
    my ($self,$bookname)=@_;
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
     "http://www.w3.org/TR/html4/strict.dtd">';
    print <<EOH
<html>
<head>
<LINK href="/icon/bridge.ico" rel="SHORTCUT ICON">
<link rel="stylesheet" type="text/css" href="../article.css">

<style type="text/css">

    div.expltext {
      display: none;
      margin-top: 1ex;
      margin-bottom: 1ex;
      margin-left: 1em;
      font-size: smaller;
    }

    div.children {
      display: none;
      margin-bottom: 1ex;
      margin-left: 2em;
    }

    .result {
	font-weight: bold;
    }

    .result div {
        padding-left: 2em;
        text-indent: -1em;
    }

    div.expltitle {
        text-decoration: underline;
	font-size: larger;
        text-indent: 22px;
        margin-left: -22px;
       
    }

    img.toggle {
        padding-right:11px;
	vertical-align:center;
        width:11px;
        height:11px;
    }

    div.explainnode {
      padding-left: 1em;
      padding-top: 1ex;
      padding-bottom: 1ex;
    }
</style>

<script type="text/javascript">
<!--
    function toggleChildren(node) {

        var newDisplay;
        var decoration;
	if (node.src.indexOf("/graphics/plus.gif")>=0) {
            newDisplay="block";
            decoration="none";
	    node.src="/graphics/minus.gif";
	} else {
            newDisplay="none";
            decoration="underline";
	    node.src="/graphics/plus.gif";
	}

        var i;
        node.parentNode.style.textDecoration=decoration;
        var parent = node.parentNode.parentNode;


        for (i=0; i<parent.childNodes.length; i++) {
            var child=parent.childNodes.item(i);
            if (child.nodeType==1 && child.className=="children") {
		child.style.display=newDisplay;
	    }
        }
    }
-->
</script>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rev="made" href="mailto:thomaso\@best.com (Thomas Andrews)">
<title>Pages from the Impossible Bridge Book ($bookname edition)</title>
</head>
<body>
<div class="back">Back to the <a href="../preface.html">Preface</a></div>
<div class="body">
<h1>Pages from the Impossible Bridge Book</h1>
<h2>($bookname edition)</h2>
EOH
;
}

sub formatEnd {
    print q!</div>
<div class="signature">
<table>
<tr><td valign="middle"><a class="image" href="../../"><img
style="border:0;width:40px;height:56px" alt="Silhouette" src="/graphics/StampSm.gif"></a></td>
<td>
Copyright 1996-2002. Thomas Andrews
(<a href="mailto:thomaso@best.com">thomaso@best.com</a>) .
</td>
</tr></table>
</div>
</body>
</html>
!;
}

sub formatDealWithExpl {
    my ($self,$page,$bookName, $explainer,@deal)=@_;
    if ($explainer) {
        print $explainer->toHTML;
    }
    $self->formatDeal($page,$bookName,@deal);
}

sub formatDeal {
    my ($self,$page,$bookName, @deal)=@_;

    print qq!<table class="deal"><tr><th colspan="11">Page $page</th></tr>\n!;
    print qq!<tr valign="bottom">
<td valign="top" align="left" width="30%" colspan="3"/>
<td width="40%" colspan="4">
    !;
    &formatHand($deal[0]);
    print qq!
<td width="30%" colspan="3"/></tr>
</tr>
<tr>
<td width="40%" colspan="4">
!;
    &formatHand($deal[3]);
    print qq!
</td><td width="20%" colspan="2"/>
<td width="40%" colspan="4">
    !;
    &formatHand($deal[1]);
    print qq!
</td>
</tr>
<tr valign="top">
<td align="left" width="30%" colspan="3"/>
<td width="40%" colspan="4">
!;
    &formatHand($deal[2]);
    print qq!
<td width="30%" colspan="3"/>
</tr></table>!;
}

sub formatHand {
    my ($hand)=@_;
    print qq!<table class="hand">!;
    for ($i=0;$i<4;$i++) { 
	print qq!<tr><td>!,$suitsymms[$i],
	qq!</td><td>!,&formatHolding($hand->[$i]),
	qq!</td></tr>\n!;
   }
   print "</table>\n";
}


sub formatHolding {
    my ($hstring)=@_;
    if ($hstring eq "") { return '&mdash;'; return; }
    $hstring =~ s/T/10/;
    return $hstring;
}

1;
