package Format::XML;

sub new {
   my($class,$cgi)=@_;
   print $cgi->header('text/xml');
   bless {},$class;
}

sub formatStart {
    my ($self,$bookname)=@_;
    print '<?xml version="1.0"?>',"\n";
    print qq!
<dealset xmlns="http://www.thomaso.com/xmlns/bridge">
!;
}

sub formatEnd {
    print q!</dealset>!;
}

sub formatDealWithExpl {
    my ($self,$page,$bookName, $explainer,@deal)=@_;
    $self->formatDeal($page,$bookName,@deal);
}

sub formatDeal {
    my ($self,$page,$bookName, @deal)=@_;
    print qq!<diagram id="$bookName:$page">\n!;
    #print qq!<diagramtitle>Page $page</diagramtitle>\n!;
    #print qq!<header><source>Impossible Bridge Book, $bookName edition</source></header>\n!;
    &formatHand('N',$deal[0]);
    &formatHand('W',$deal[3]);
    &formatHand('E',$deal[1]);
    &formatHand('S',$deal[2]);
    print q!</diagram>!;
}

sub formatHand {
   my ($seat,$hand)=@_;
   print qq!<hand seat="$seat" sp="!,$hand->[0],'"',
                           qq! he="!,$hand->[1],'"',
                           qq! di="!,$hand->[2],'"',
                           qq! cl="!,$hand->[3],'"',"/>\n";
}


sub formatHolding {
    my ($hstring)=@_;
    if ($hstring eq "") { return '&mdash;'; return; }
    $hstring =~ s/T/10/;
    return $hstring;
}

1;
