package Impossible::Pavlicek;
use Math::BigInt;

sub new {
    my ($this)={};
    bless $this, shift;
}

sub fraction {
    my ($val,$numer,$denom)=@_;
    return $val*$numer/$denom;
}

sub addState {
    my($explainer, $K, $N, $E, $S, $W);
}

sub decode {
    my ($this,$pageNo,$explainer)=@_;
    my (@result)=();
    my (@cardsNeeded)=(13,13,13,13);
    my ($K)=new Math::BigInt("53644737765488792839237440000");

    my ($C,$hand);
    for ($C=52; $C>0; $C--) {
	my ($substep)=undef;
	my ($num)=52-$C;
        my  ($Sum)=0;
	if ($explainer) {
	    $substep=
		$explainer->newSubStep("Determine who gets card $num" ,
				       "There are K=$K deals matching conditions so far.<br>".
				       "We are seeking the deal with index $pageNo among these deals<br>".
				       "North gets this card for the first $cardsNeeded[0]/${C} of these deals,<br>".
				       "East gets this card for the next $cardsNeeded[1]/${C} of these deals,<br>".
				       "South gets this card for the next $cardsNeeded[2]/${C} of these deals, and<br>".
				       "West gets this card for the last $cardsNeeded[3]/${C} of these deals.<br>");
	    
	}
        my(@hands)=qw(North East South West);
	for ($hand=0; $hand<4;$hand++) {
	    my($X)=&fraction($K,$cardsNeeded[$hand],$C);
            my($subsubstep)=undef;
            if ($substep) {
                my($min)=$Sum;
                my($max)=$Sum+$X-1;
                $subsubstep=$substep->newSubStep("Check if card $num goes to hand $hands[$hand]",
	"$hands[$hand] gets this card if Index=$pageNo is between $min and $max (exactly $cardsNeeded[$hand] out of $C of the deals)");
                $Sum=$Sum+$X;
            }
	    if ($pageNo<$X) {
		$result[52-$C]=$hand;
		$K=$X;
                $cardsNeeded[$hand]--;
		if ($subsubstep) {
                    $subsubstep->addResult("<div>Yes</div>");
		    $substep->addResult("<div>". $hands[$hand]. " gets card $num</div>");
		    $substep->addResult("<div>Narrowed down to K=$K deals</div>");
		    
		    if ($C>0) {
			$substep->addResult("<div>Seeking Index=$pageNo among those deals</div>");
		    }
		}
	        last;
	    } else {
                if ($subsubstep) {
                    $subsubstep->addResult("<div>No</div>");
                }
		$pageNo -= $X;
	    }
	}
    }
    return @result;
}

1;
