package Numeric::IncreasingSequence;

use Numeric::Choose;

use strict vars;

sub decode {
    my($index,$length,$explainer,$handname)=@_;
 
    my(@result)=();
    my($startIndex)=$index;
    while($length>0) {
 	my($lastValue)=new Math::BigInt(0);
        my($num)=$length;
        my($nextValue);
        while ($index>=($nextValue=&::choose($num,$length))) {
	    $num++;
            $lastValue=$nextValue;          
        }
        push(@result,$num-1);
        $index = $index - $lastValue;
        $length--;
    }
    
    @result=reverse(@result);
    if ($explainer) {
        my($text1)="$startIndex = ";
        foreach (0..12) {
	    if ($_>0) { $text1 .= " + "; }
            $text1 .= "choose(<span class='result'>".$result[$_]."</span>,". ($_+1) . ")";
	}
	my ($text2)="${handname}Sequence=[".join(',',@result)."]";
	my ($text)="<div>$text1</div>";
        my($substep)=$explainer->newSubStep(
               "Decode $handname index: $startIndex",
		$text)->addResult($text2);
    }
    return @result;
}

sub encode {
    my(@sequence)=@_;
    my($sum)=new Math::BigInt("0");
    my ($length)=scalar(@sequence);

    my ($i);
    for ($i=0; $i<$length; $i++) {
	$sum = $sum + &::choose($sequence[$i],$i+1);
    }
    return $sum;
}
1;
